{known_script id="jquery.ui" src=$ROOT_URL|@cat:"themes/default/js/ui/packed/ui.core.packed.js"}
{known_script id="jquery.ui.dialog" src=$ROOT_URL|@cat:"themes/default/js/ui/packed/ui.dialog.packed.js"}
{known_script id="gpc.tagSelector" src=$ROOT_URL|@cat:"plugins/GrumPluginClasses/js/ui.tagSelector.packed.js"}

{literal}

<script type="text/javascript">
/**
 * include this template in a page and use dialogChooseASETagBox.show({options}) to display
 * the dialog box
 *
 */
dialogChooseASETagBox = function()
{
  var dialogOptions = {
      id:'',
      eventOk:null,
      cBuilder:null,

      values: {
        tags:[],
        method:'AND'
      },
    };

  /**
   * initialize the dialog box
   */
  var initDialogBox = function()
  {
    $("#iDialogASETagChoose")
    .dialog(
      {
        autoOpen: false,
        resizable: false,
        width:550,
        height:200,
        modal: true,
        draggable:true,
        dialogClass: 'gcBgTabSheet gcBorder',
        title: '{/literal}{"ase_search_tags"|@translate}{literal}',
        open: function(event, ui)
        {
        },
        buttons:
        {
          '{/literal}{"ase_ok"|@translate}{literal}':
            function()
            {
              if(checkValidity())
              {
                dialogOptions.values.tags=$("#iBDTagTags").tagSelector('value');
                dialogOptions.values.method=$('[name=fBDTagMethod]:checked').val();

                if(dialogOptions.cBuilder!=null)
                {
                  setCBuilderItem(dialogOptions.id, dialogOptions.values);
                }

                if(dialogOptions.eventOk!=null)
                {
                  dialogOptions.eventOk(dialogOptions.id, dialogOptions.values);
                }
                $(this).dialog('close');
              }
            },
          '{/literal}{"ase_cancel"|@translate}{literal}':
            function()
            {
              $(this).dialog('close');
            }
        }
      }
    );

    $("#iBDTagTags").tagSelector(
      {
        listMaxWidth:400,
        listMaxHeight:350,
        maximumTagLoaded:150,
        filter:'affected',
        {/literal}
        textStart:"{'ase_tag_start_to_type_text'|@translate}",
        textDisplay:"{'ase_tag_x_tags_display'|@translate}",
        textFound:"{'ase_tag_x_tags_found'|@translate}",
          {if is_admin()}
        mode:'admin',
          {else}
        mode:'public',
          {/if}
        {literal}
      }
    );

  }

  /**
   * check the validity of the condition
   * return Boolean : true if OK, otherwise false
   */
  var checkValidity = function ()
  {
    $(".error").removeClass('error');
    returned=true;

    if($('#iBDTagTags').tagSelector('numberOfTags')==0)
    {
      $('#iBDTagTags').addClass('error');
      returned=false;
      alert("{/literal}{'ase_error_no_tags_selected'|@translate}{literal}");
    }
    return(returned);
  }


  /**
   * the show() function display and manage a dialog box to choose categories
   * and the kind of test to apply
   *
   * @param options : properties to manage the dialog box
   *                  - id : a string to identify a DOM object ; this parameter
   *                         is given to the callback when the OK button is pushed
   *                  - values : an object with 3 properties
   *                               - withHD : with our without HD picture
   *                  - eventOK : a callback function, with 2 parameters : id of
   *                              the given DOM object and values parameted
   *                  - cBuilder : a criteriaBuilder object
   *                               if set, the dialog box manage automaticaly
   *                               the criteria builder interface
   */
  this.show = function (options)
  {
    showDialog(options);
  }

  /**
   * private function used to show the dialog box
   */
  var showDialog = function(options)
  {
    if(options.id!=null)
    {
      dialogOptions.id=options.id;
    }
    else
    {
      dialogOptions.id='';
    }

    if(options.eventOk!=null)
    {
      dialogOptions.eventOk=options.eventOk;
    }

    if(options.cBuilder!=null)
    {
      dialogOptions.cBuilder=options.cBuilder;
      dialogOptions.cBuilder.doAction('setOptions',
        {
          onEdit:function (e) { editCB(e.data); },
          onDelete:function (e) { deleteCB(e.data); },
        }
      );
    }

    if(options.values!=null)
    {
      dialogOptions.values=jQuery.extend(dialogOptions.values, options.values);
    }
    else
    {
      dialogOptions.values.tags=[];
      dialogOptions.values.method='AND';
    }

    $("#iBDTagTags").tagSelector('value', 'clear').tagSelector('value', dialogOptions.values.tags);
    $('#iBDTagMethodAND').attr('checked', dialogOptions.values.method=='AND');
    $('#iBDTagMethodOR').attr('checked', dialogOptions.values.method=='OR');

    $("#iDialogASETagChoose").dialog('open');
  }



  /**
   * manage the 'edit' button from criteria builder interface
   * @param String itemId : the itemId
   */
  var editCB = function (itemId)
  {
    extraData=dialogOptions.cBuilder.doAction('getExtraData', itemId);
    showDialog(
      {
        id:itemId,
        values:
          {
            tags:extraData.param.tags,
            method:extraData.param.method,
          },
      }
    );
  }

  /**
   * manage the 'delete' button from criteria builder interface
   * @param String itemId : the itemId
   */
  var deleteCB = function (itemId)
  {
    dialogOptions.cBuilder.doAction('delete', itemId);
  }

  /**
   * set the content for the cBuilder item
   */
  var setCBuilderItem = function(id)
  {
    var content="";

    for(var i=0;i<dialogOptions.values.tags.length;i++)
    {
      if(content!='') content+=', ';
      content+=dialogOptions.values.tags[i].name;
    }


    if(dialogOptions.values.method=='AND')
    {
      content="<div>{/literal}{'ase_tag_method_and_text'|@translate}{literal}&nbsp;<span style='font-style:italic;'>"+content+"</span>";
    }
    else
    {
      content="<div>{/literal}{'ase_tag_method_or_text'|@translate}{literal}&nbsp;<span style='font-style:italic;'>"+content+"</span>";
    }

    content+="</div>";

    if(id=='')
    {
      //no id:add a new item in the list
      dialogOptions.cBuilder.doAction(
        'add',
        content,
        criteriaBuilder.makeExtendedData(
          'ASETag',
          {
            tags:dialogOptions.values.tags,
            method:dialogOptions.values.method,
          }
        )
      );
    }
    else
    {
      // update item
      dialogOptions.cBuilder.doAction(
        'edit',
        id,
        content,
        criteriaBuilder.makeExtendedData(
          'ASETag',
          {
            tags:dialogOptions.values.tags,
            method:dialogOptions.values.method,
          }
        )
      );
    }
  }

  initDialogBox();
}


</script>
{/literal}

<div id="iDialogASETagChoose" style='display:none;'>

  <table class="formtable">
    <tr>
      <td>{'ase_tags'|@translate}</td>
      <td>
        <div id="iBDTagTags" style="width:400px;"></div>
      </td>
    </tr>

    <tr>
      <td></td>
      <td>
        <label><input type='radio' id='iBDTagMethodAND' name='fBDTagMethod' value="AND">&nbsp;{'ase_tag_method_and'|@translate}</label><br>
        <label><input type='radio' id='iBDTagMethodOR' name='fBDTagMethod' value="OR">&nbsp;{'ase_tag_method_or'|@translate}</label><br>
      </td>
    </tr>

  </table>

</div>


